
*This do file generate a csv file, index.csv,  containing the h-index for given combinations of a,b and c, and another csv file, csdata.csv containing other author level information such as field weights and school affiliation. Importing the two csv files into matlab yield the mat file, CSdata.mat. 
*This file calls compsci.dta, getsearchname.dta and parseddata.dta. 

clear
set mem 200m
set matsize 3000



********Set the list of a and b**************************

local lista "0.5 1 2 5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80 85 90 95 100"
local listb "1 2 3"
local listc "0 0.25 0.5 0.75 1 1.5 2 3"

********Index Calculation *******************************

capture program drop indexcal

program indexcal /* read data from disk, calculating mnindex, i.e. the Hirsch index, using given a, b and the coauthor parameter, c */
args a b c

capture clear

use parseddata.dta

gsort fixedname - numcitations

by fixedname: gen npaper=sum(1/(numauthors)^`c')

gen mnindex=min((numcitations/`a')^(1/`b'),npaper)

collapse (max) mnindex, by(fixedname) 

merge fixedname using facultylist.dta, unique sort _merge(_merge2)
keep if _merge2==3
drop _merge2

gen pos=.
replace pos=1 if position=="Assistant Professor"
replace pos=2 if position=="Associate Professor"
replace pos=3 if position=="Professor"

replace mnindex = max(mnindex, (1/`a')^(1/`b'))


end

***********************

capture program drop indexcalallcites

program indexcalallcites /* read data from disk, calculating mnindex, i.e. the Hirsch index, using given a, b and the coauthor parameter, c */

capture clear

use parseddata.dta

gsort fixedname - numcitations

replace numcitations = numcitations/numauthors

collapse (sum) numcitations, by(fixedname) 

rename numcitations mnindex

merge fixedname using facultylist.dta, unique sort _merge(_merge2)
keep if _merge2==3
drop _merge2

gen pos=.
replace pos=1 if position=="Assistant Professor"
replace pos=2 if position=="Associate Professor"
replace pos=3 if position=="Professor"

end

************************

capture program drop indexcalallcites50

program indexcalallcites50 /* read data from disk, calculating mnindex, i.e. the Hirsch index, using given a, b and the coauthor parameter, c */

capture clear

use parseddata.dta

gsort fixedname - numcitations

egen paperrank = rank(-numcitations), unique by(fixedname)

replace numcitations = numcitations/numauthors

keep if paperrank<=50

collapse (sum) numcitations, by(fixedname) 

rename numcitations mnindex

merge fixedname using facultylist.dta, unique sort _merge(_merge2)
keep if _merge2==3
drop _merge2

gen pos=.
replace pos=1 if position=="Assistant Professor"
replace pos=2 if position=="Associate Professor"
replace pos=3 if position=="Professor"

end

*************************

capture program drop indexcalallcites20

program indexcalallcites20 /* read data from disk, calculating mnindex, i.e. the Hirsch index, using given a, b and the coauthor parameter, c */

capture clear

use parseddata.dta

gsort fixedname - numcitations

egen paperrank = rank(-numcitations), unique by(fixedname)

replace numcitations = numcitations/numauthors

keep if paperrank<=20

collapse (sum) numcitations, by(fixedname) 

rename numcitations mnindex

merge fixedname using facultylist.dta, unique sort _merge(_merge2)
keep if _merge2==3
drop _merge2

gen pos=.
replace pos=1 if position=="Assistant Professor"
replace pos=2 if position=="Associate Professor"
replace pos=3 if position=="Professor"

end

************************************************************

matrix Indexmat=J(1529,1,0)

foreach A in `lista' {
foreach B in `listb' {
foreach C in `listc' {
indexcal `A' `B' `C'
mkmat mnindex, mat(indexat)
matrix Indexmat=(Indexmat,indexat)
}
}
}


indexcalallcites
replace mnindex = mnindex + 1
mkmat mnindex, mat(indexat)
matrix Indexmat=(Indexmat,indexat)
gen logmnindex = log(mnindex)
replace logmnindex = max(logmnindex, log(2))
mkmat logmnindex, mat(logindexat)
matrix Indexmat=(Indexmat,logindexat)

indexcalallcites20
replace mnindex = mnindex + 1
mkmat mnindex, mat(indexat)
matrix Indexmat=(Indexmat,indexat)
gen logmnindex = log(mnindex)
replace logmnindex = max(logmnindex, log(2))
mkmat logmnindex, mat(logindexat)
matrix Indexmat=(Indexmat,logindexat)

indexcalallcites50
replace mnindex = mnindex + 1
mkmat mnindex, mat(indexat)
matrix Indexmat=(Indexmat,indexat)
gen logmnindex = log(mnindex)
replace logmnindex = max(logmnindex, log(2))
mkmat logmnindex, mat(logindexat)
matrix Indexmat=(Indexmat,logindexat)

clear
indexcal 5 2 1
keep fixedname
matrix Indexmat=Indexmat[1...,2...]
matrix rename Indexmat Index
svmat Index

outsheet using "index.csv", comma nolabel replace

indexcal 5 2 1
gen Tyear=2012-phdyear
gen byte tdum = tenure== "Yes"
drop tenure
rename tdum tenure

outsheet fixedname nrc tenure Tyear b-m pos using "authdata.csv", comma nolabel replace





