clear
set mem 500m
set matsize 1000

clear
insheet fixedname searchedname using getsearchname.csv, comma
sort searchedname
egen a=count(1), by(searchedname)
drop if a!=1 & fixedname!="Robert Lucas"
drop a
save getsearchname.dta, replace

clear
insheet fixedname reason using "droplist.csv"
save droplist.dta, replace

clear
insheet using "fixedfacultyinfo.csv"
sort fixedname
replace b=0
replace d=0
replace c=0
replace s=0
replace f=0
replace h=0
replace i=0
replace n=0
replace r=0
replace l=0
replace p=0
replace e=0
replace t=0
replace o=0
replace m=0
replace b=4 if f1=="b"
replace d=4 if f1=="d"
replace c=4 if f1=="c"
replace s=4 if f1=="s"
replace f=4 if f1=="f"
replace h=4 if f1=="h"
replace i=4 if f1=="i"
replace n=4 if f1=="n"
replace r=4 if f1=="r"
replace l=4 if f1=="l"
replace p=4 if f1=="p"
replace e=4 if f1=="e"
replace t=4 if f1=="t"
replace o=4 if f1=="o"
replace m=4 if f1=="m"
replace b=2+b if f2=="b"
replace d=2+d if f2=="d"
replace c=2+c if f2=="c"
replace s=2+s if f2=="s"
replace f=2+f if f2=="f"
replace h=2+h if f2=="h"
replace i=2+i if f2=="i"
replace n=2+n if f2=="n"
replace r=2+r if f2=="r"
replace l=2+l if f2=="l"
replace p=2+p if f2=="p"
replace e=2+e if f2=="e"
replace t=2+t if f2=="t"
replace o=2+o if f2=="o"
replace m=2+m if f2=="m"
replace b=1+b if f3=="b"
replace d=1+d if f3=="d"
replace c=1+c if f3=="c"
replace s=1+s if f3=="s"
replace f=1+f if f3=="f"
replace h=1+h if f3=="h"
replace i=1+i if f3=="i"
replace n=1+n if f3=="n"
replace r=1+r if f3=="r"
replace l=1+l if f3=="l"
replace p=1+p if f3=="p"
replace e=1+e if f3=="e"
replace t=1+t if f3=="t"
replace o=1+o if f3=="o"
replace m=1+m if f3=="m"
gen total = b+d+c+s+f+h+i+n+r+l+p+e+t+o+m
replace b=b/total
replace d=d/total
replace c=c/total
replace s=s/total
replace f=f/total
replace h=h/total
replace i=i/total
replace n=n/total
replace r=r/total
replace l=l/total
replace p=p/total
replace e=e/total
replace t=t/total
replace o=o/total
replace m=m/total

gen nrc=.
gen nrcscore=.
replace nrc = 37 if school=="Arizona"
replace nrc = 7 if school=="Berkeley"
replace nrc = 43 if school=="Boston College"
replace nrc = 21 if school=="Boston U"
replace nrc = 23 if school=="Brown"
replace nrc = 19 if school=="Cal Tech"
replace nrc = 12 if school=="Columbia"
replace nrc = 18 if school=="Cornell"
replace nrc = 22 if school=="Duke"
replace nrc = 41 if school=="Florida"
replace nrc = 47 if school=="George Mason"
replace nrc = 1 if school=="Harvard"
replace nrc = 28 if school=="Illinois"
replace nrc = 44 if school=="Indiana"
replace nrc = 30 if school=="Iowa"
replace nrc = 36 if school=="Iowa St"
replace nrc = 32 if school=="Johns Hopkins"
replace nrc = 20 if school=="Maryland"
replace nrc = 13 if school=="Michigan"
replace nrc = 27 if school=="Michigan St"
replace nrc = 10 if school=="Minnesota"
replace nrc = 3 if school=="MIT"
replace nrc = 42 if school=="NC State"
replace nrc = 25 if school=="North Carolina"
replace nrc = 9 if school=="Northwestern"
replace nrc = 17 if school=="NYU"
replace nrc = 35 if school=="Ohio State"
replace nrc = 45 if school=="Penn State"
replace nrc = 34 if school=="Pittsburgh"
replace nrc = 5 if school=="Princeton"
replace nrc = 50 if school=="Purdue"
replace nrc = 46 if school=="Rice"
replace nrc = 14 if school=="Rochester"
replace nrc = 4 if school=="Stanford"
replace nrc = 39 if school=="SUNY SB"
replace nrc = 31 if school=="Texas"
replace nrc = 33 if school=="Texas A&M"
replace nrc = 26 if school=="U Washington"
replace nrc = 38 if school=="UC Davis"
replace nrc = 49 if school=="UC Santa Barbara"
replace nrc = 11 if school=="UCLA"
replace nrc = 16 if school=="UCSD"
replace nrc = 2 if school=="University of Chicago"
replace nrc = 8 if school=="Upenn"
replace nrc = 40 if school=="USC"
replace nrc = 48 if school=="Vanderbilt"
replace nrc = 24 if school=="Virginia"
replace nrc = 29 if school=="Wash StL"
replace nrc = 15 if school=="Wisconsin"
replace nrc = 6 if school=="Yale"
replace nrcscore = 2.78 if school=="Arizona"
replace nrcscore = 4.55 if school=="Berkeley"
replace nrcscore = 2.53 if school=="Boston College"
replace nrcscore = 3.39 if school=="Boston U"
replace nrcscore = 3.34 if school=="Brown"
replace nrcscore = 3.54 if school=="Cal Tech"
replace nrcscore = 4.07 if school=="Columbia"
replace nrcscore = 3.56 if school=="Cornell"
replace nrcscore = 3.36 if school=="Duke"
replace nrcscore = 2.65 if school=="Florida"
replace nrcscore = 2.46 if school=="George Mason"
replace nrcscore = 4.95 if school=="Harvard"
replace nrcscore = 3.07 if school=="Illinois"
replace nrcscore = 2.51 if school=="Indiana"
replace nrcscore = 2.97 if school=="Iowa"
replace nrcscore = 2.78 if school=="Iowa St"
replace nrcscore = 2.87 if school=="Johns Hopkins"
replace nrcscore = 3.46 if school=="Maryland"
replace nrcscore = 4.03 if school=="Michigan"
replace nrcscore = 3.09 if school=="Michigan St"
replace nrcscore = 4.22 if school=="Minnesota"
replace nrcscore = 4.93 if school=="MIT"
replace nrcscore = 2.61 if school=="NC State"
replace nrcscore = 3.16 if school=="North Carolina"
replace nrcscore = 4.39 if school=="Northwestern"
replace nrcscore = 3.62 if school=="NYU"
replace nrcscore = 2.83 if school=="Ohio State"
replace nrcscore = 2.49 if school=="Penn State"
replace nrcscore = 2.83 if school=="Pittsburgh"
replace nrcscore = 4.84 if school=="Princeton"
replace nrcscore = 2.37 if school=="Purdue"
replace nrcscore = 2.47 if school=="Rice"
replace nrcscore = 4.01 if school=="Rochester"
replace nrcscore = 4.92 if school=="Stanford"
replace nrcscore = 2.73 if school=="SUNY SB"
replace nrcscore = 2.91 if school=="Texas"
replace nrcscore = 2.83 if school=="Texas A&M"
replace nrcscore = 3.15 if school=="U Washington"
replace nrcscore = 2.75 if school=="UC Davis"
replace nrcscore = 2.38 if school=="UC Santa Barbara"
replace nrcscore = 4.12 if school=="UCLA"
replace nrcscore = 3.8 if school=="UCSD"
replace nrcscore = 4.95 if school=="University of Chicago"
replace nrcscore = 4.43 if school=="Upenn"
replace nrcscore = 2.66 if school=="USC"
replace nrcscore = 2.4 if school=="Vanderbilt"
replace nrcscore = 3.2 if school=="Virginia"
replace nrcscore = 3 if school=="Wash StL"
replace nrcscore = 3.93 if school=="Wisconsin"
replace nrcscore = 4.7 if school=="Yale"

merge fixedname using "droplist.dta", unique sort _merge(_todrop)
drop if _todrop!=1
drop _todrop
sort fixedname

drop if phdyear<2002 & position == "Assistant Professor"

save facultylist,replace

clear
insheet SearchedName RankonPage PaperDisplayed TotalPaper booklabel NumAuthors NumCitations YearPublished title link using parseddata.csv, comma
g byte book = booklabel==1 & (wordcount(title)<=2 | numauthors==1 | (numauthors==2 & (wordcount(title)<=8 | regexm(title," and "))) | (numauthors==3 & regexm(title,":") & wordcount(title)<=7) | regexm(title,"ntroduction"))
replace numcitations=200 if numcitations > 200 & book == 1
drop if numcitations==. | numcitations<0
sort searchedname
merge searchedname using getsearchname.dta, uniqusing
ta _merge
drop if _merge==1
sort fixedname
merge fixedname using facultylist.dta, uniqusing _merge(_merge2)
ta _merge2
keep if _merge2==3

duplicates drop

gen publishyear = real(yearpublished)
drop if publishyear <= phdyear-4 & publishyear>=1000
save parseddata.dta, replace
