function [ llh, AdjIndex, llhlist] = llhlogit2(x)
global data Nadj Nsch
% Nadj: the number of linear adjustment term. Nsch: the number of schools
% data: each row corresponds to an author, the columns are index,nrc school ranking,linear adjustment terms  
% x (the parameters): beta0, beta1, sdums (Nsch of them), coefficients of
% linear adjustment terms  (Nadj of them)

%determine size of the data
datasize = size(data);

%get school population
schoolsize = zeros(1,Nsch);
for i = 1:Nsch
    schoolsize(i) = sum(data(:,2)==i);
end

%Adjust log index by linear terms
if Nadj == 0
AdjIndex = log(data(:,1));
else    
AdjIndex = log(data(:,1)) + data(:,3:end) * x(3+Nsch:2+Nsch+Nadj)';
end

%Calculate log likelihood using a logit model
p=ones(datasize(1),1)*x(1)*log(schoolsize); 
p=p-x(2)*(AdjIndex*ones(1,Nsch)-ones(datasize(1),1)*x(3:2+Nsch)).^2;
p=exp(p);
p=p((data(:,2)-1)*datasize(1)+(1:datasize(1))')./sum(p,2);
llhlist = log(p);
llh = mean(log(p));
end