function [ loglikelihood] = llhprobit(x )
global data Nadj Nsch
% Nadj: the number of linear adjustment term. Nsch: the number of schools
% data: each row corresponds to an author, the columns are index,nrc school ranking,linear adjustment terms  
% x (the parameters): sigma, school intervals (Nsch-1 of them), coefficients of linear adjustment terms (Nadj of them)

% School interval is the interval between consecutive cutoff points in the
% orded probit model. 
cut = [-1000 cumsum(x(2:Nsch)) 1000]; 
cut = cut(end:-1:1);
meanlogy = log(data(:,1)) +  data(:,3:end) * x(Nsch+1:Nsch+Nadj)';
logllh = log( normcdf((cut(data(:,2))' - meanlogy) / x(1)) - normcdf((cut(data(:,2)+1)'-meanlogy) / x(1)));
loglikelihood = mean(logllh);
end